/////////////////////////////////////////////////////////////
// CINEMA 4D SDK                                           //
/////////////////////////////////////////////////////////////
// (c) MAXON Computer GmbH, all rights reserved            //
/////////////////////////////////////////////////////////////

#ifndef _C4D_COLORS_H_
#define _C4D_COLORS_H_

enum
{
	COLOR_3DTEXT				 = 997,	// for 3d text
	COLOR_DEPRECATED_XOR = 998,	// deprecated XOR lines => use LassoSelection instead
	COLOR_TRANS					 = 999,	// transparent background for text

	COLOR_BG						 = 1000,
	COLOR_BGEDIT				 = 1001,
	COLOR_BGFOCUS				 = 1002,
	COLOR_TEXT					 = 1003,
	COLOR_TEXTFOCUS			 = 1004,
	COLOR_EDGELT				 = 1005,	// helle Kante
	COLOR_EDGEWH				 = 1006,	// hellste Kante
	COLOR_EDGEDK				 = 1007,	// dunkle Kante
	COLOR_EDGEBL				 = 1008,	// dunkelste Kante
	COLOR_DBARFG1				 = 1009,	// DialogBar
	COLOR_DBARBG1				 = 1010,	// DialogBar
	COLOR_DBARFG2				 = 1011,	// DialogBar
	COLOR_DBARBG2				 = 1012,	// DialogBar
	COLOR_BGGADGET			 = 1013,	// GadgetBGColor

	COLOR_BGSELECTEDTEXT = 1014,	// Selected Text in Gadgets
	COLOR_FGSELECTEDTEXT = 1015,	// Selected Text in Gadgets

	EX_COLOR_TIMELINE		 = 1016,	// Timeline
	COLOR_BGTRISTATE		 = 1017,	// bgcolor for tristates

	COLOR_BG_DARK1			 = 1100,
	COLOR_BG_DARK2			 = 1101,

	COLOR_EMBOSS_WH,
	COLOR_EMBOSS_DK,

	EX_COLOR_TIMELINE_BG,
	EX_COLOR_TIMELINE_BG_DARK,
	EX_COLOR_TIMELINE_TEXT,
	EX_COLOR_TIMELINE_TEXT_SELECTED,
	EX_COLOR_TIMELINE_TEXT_SELECTED2,
	EX_COLOR_TIMELINE_LINES,
	EX_COLOR_TIMELINE_LINES_SEL,
	EX_COLOR_TIMELINE_LINES_SEPARATOR1,
	EX_COLOR_TIMELINE_LINES_SEPARATOR2,
	EX_COLOR_TIMELINE_TREE,
	EX_COLOR_TIMELINE_LOOP,
	EX_COLOR_TIMELINE_SELECTION,
	EX_COLOR_TIMELINE_TICKS1,
	EX_COLOR_TIMELINE_TICKS2,
	EX_COLOR_TIMELINESCROLLER_MINMAX,
	EX_COLOR_TIMELINESCROLLER_CURRENT,

	EX_COLOR_BROWSER_LINES_SELECTED,

	EX_COLOR_FCURVE_BG,
	EX_COLOR_FCURVE_TEXT,
	EX_COLOR_FCURVE_LINES,
	EX_COLOR_FCURVE_MAINGRID,
	EX_COLOR_FCURVE_SUBGRID,
	EX_COLOR_FCURVE_LLTGRAY,
	EX_COLOR_FCURVE_GRAY1,
	EX_COLOR_FCURVE_GRAY2,
	EX_COLOR_FCURVE_GRAY3,
	EX_COLOR_FCURVE_POINTSELECTED,

	COLOR_MATERIALMANAGER_BG,
	COLOR_MATERIALMANAGER_TEXT,
	COLOR_MATERIALMANAGER_TEXT_SELECTED,
	COLOR_MATERIALMANAGER_SELECTED,

	EX_COLOR_OBJECTMANAGER_BG,
	EX_COLOR_OBJECTMANAGER_ACTIVECAMERA,
	EX_COLOR_OBJECTMANAGER_INACTIVECAMERA,
	EX_COLOR_OBJECTMANAGER_TEXT,
	EX_COLOR_OBJECTMANAGER_TEXT_ACTIVE,
	EX_COLOR_OBJECTMANAGER_TEXT_ACTIVE2,
	EX_COLOR_OBJECTMANAGER_SELECTEDTAG,
	EX_COLOR_OBJECTMANAGER_TREE,

	COLOR_SPREADSHEET_BG,
	COLOR_SPREADSHEET_TEXT,
	COLOR_SPREADSHEET_EDITBG,
	COLOR_SPREADSHEET_EDITTEXT,
	COLOR_SPREADSHEET_SELECTED,

	COLOR_CONSOLE_BG,
	COLOR_CONSOLE_TEXT,

	COLOR_PAINTER_SELECTED,
	COLOR_PAINTER_TREE,

	COLOR_SYNTAX_COFFEE,
	COLOR_SYNTAX_INCLUDE,
	COLOR_SYNTAX_COMMENT,
	COLOR_SYNTAX_COMMENTWRONG,
	COLOR_SYNTAX_STRING,

	COLOR_TEXT_SELECTED,
	COLOR_TEXT_SELECTED_DARK,
	COLOR_TEXT_DISABLED,
	COLOR_TEXT_EDIT,
	COLOR_TEXT_EDIT_DISABLED,
	COLOR_TEXT_MENU,
	COLOR_TEXT_MENU_DISABLED,
	COLOR_TEXT_TAB,
	COLOR_TEXT_TAB_DISABLED,
	COLOR_TEXT_BUTTON,
	COLOR_TEXT_BUTTON_DISABLED,
	COLOR_TEXT_COMBO,
	COLOR_TEXT_COMBO_DISABLED,

	COLOR_MENU_BG,
	COLOR_MENU_BG_SELECTED,
	COLOR_MENU_TEXT,
	COLOR_MENU_TEXT_DISABLED,
	COLOR_MENU_TEXT_SELECTED,
	COLOR_MENU_BORDER_WH,
	COLOR_MENU_BORDER_DK,

	EX_COLOR_TIMELINE_LAYER0,
	EX_COLOR_TIMELINE_LAYER1,
	EX_COLOR_TIMELINE_LAYER2,
	EX_COLOR_TIMELINE_LAYER3,
	EX_COLOR_TIMELINE_LAYER4,
	EX_COLOR_TIMELINE_LAYER5,
	EX_COLOR_TIMELINE_LAYER6,
	EX_COLOR_TIMELINE_LAYER7,

	//new
	COLOR_BG_MM_E_ACTIVE_TEXTURE,
	COLOR_FG_MM_E_ACTIVE_TEXTURE,
	COLOR_BG_MM_E_INACTIVE_TEXTURE,
	COLOR_FG_MM_E_INACTIVE_TEXTURE,
	COLOR_BG_MM_E_SELECTED_LAYER,
	COLOR_FG_MM_E_SELECTED_LAYER,
	COLOR_BG_MM_E_ACTIVE_LAYER,
	COLOR_FG_MM_E_ACTIVE_LAYER,
	COLOR_BG_MM_E_INACTIVE_LAYER,
	COLOR_FG_MM_E_INACTIVE_LAYER,

	UNUSED_COLOR_FG_MM_C_ACTIVE_LAYER_ACT_TEX,
	UNUSED_COLOR_FG_MM_C_ACTIVE_LAYER_INACT_TEX,

	COLOR_BG_TEXTUREVIEW,
	EX_COLOR_OBJECTMANAGER_TEXT_ACTIVE3,

	COLOR_SYNTAX_CONSTANT,
	COLOR_SYNTAX_FUNCTION,
	COLOR_SYNTAX_CLASS,
	COLOR_SYNTAX_MEMBER,

	COLOR_CTIMELINE_GRID,
	COLOR_CTIMELINE_POSITION,
	COLOR_CTIMELINE_ROTATION,
	COLOR_CTIMELINE_SCALE,
	EX_COLOR_CTIMELINE_PLA,
	EX_COLOR_CTIMELINE_COLOR,
	COLOR_CTIMELINE_GENERAL,
	EX_COLOR_CTIMELINE_MASTER,
	EX_COLOR_CTIMELINE_MASTERIDENTICAL,
	COLOR_CTIMELINE_CURRENTFRAME,
	COLOR_CTIMELINE_BGPREVIEW,

	COLOR_DBARBG3,

	COLOR_CONTENTBROWSER_TEXT,
	COLOR_CONTENTBROWSER_BG_TEXT_ACT,
	COLOR_CONTENTBROWSER_BG_TEXT_INACT,
	COLOR_CONTENTBROWSER_FG_TEXT_ACT,
	COLOR_CONTENTBROWSER_FG_TEXT_INACT,
	COLOR_CONTENTBROWSER_NOTAVAILABLE,

	COLOR_CTIMELINE_GRIDTEXT,
	COLOR_CTIMELINE_GRIDTEXTSUB,
	COLOR_CTIMELINE_SELECTION,
	COLOR_CTIMELINE_SELECTION2,
	COLOR_CTIMELINE_HIGHLIGHT,
	COLOR_CTIMELINE_REGIONAREA,
	COLOR_CTIMELINE_MARKER,
	COLOR_CTIMELINE_BGOUTSIDE,
	COLOR_CTIMELINE_BG,
	COLOR_CTIMELINE_GREY,
	COLOR_CTIMELINE_MASTERGREY,
	COLOR_CTIMELINE_TEXTCOLOR,
	COLOR_CTIMELINE_CURSORINDICATOR,
	COLOR_CTIMELINE_MARKERTEXT,
	COLOR_CTIMELINE_FCHIGHLIGHT,
	COLOR_CTIMELINE_FCKEY,
	COLOR_CTIMELINE_FCSELECTION,
	COLOR_CTIMELINE_SNAPSHOT,
	COLOR_CTIMELINE_TANGENT,
	COLOR_CTIMELINE_TANGENT2,
	COLOR_CTIMELINE_SEQUENCE,
	COLOR_CTIMELINE_KEYSYMBOLS,

	COLOR_SB_BG1,
	COLOR_SB_BG2,
	COLOR_SB_TREE1,
	COLOR_SB_TREE2,
	COLOR_SB_TEXT,
	COLOR_SB_TEXT_BORDER,
	COLOR_SB_TEXT_ACTIVE1,
	COLOR_SB_TEXT_ACTIVE2,
	COLOR_SB_TEXT_FOLDER_MAIN,
	COLOR_SB_TEXT_FOLDER_SUB,
	COLOR_SB_LAYER_BORDER,
	COLOR_SB_TEXTHG1,
	COLOR_SB_TEXTHG2,

	COLOR_BG_PALETTE,
	COLOR_MENU_BG_ICON,

	COLOR_POWERFRAME,
	COLOR_POWERFRAMEDRAG,
	COLOR_POWERFRAMEMARKER,
	COLOR_POWERKEYUNSELECTED,
	COLOR_POWERKEYSELECTED,
	COLOR_POWERBG,
	COLOR_POWEREDGE,
	COLOR_POWERLOOP,
	COLOR_POWERSELECTED,
	COLOR_POWERSLIDEBG,
	COLOR_POWERSLIDEHANDLES,
	COLOR_POWERBGDRAG,
	COLOR_POWERHANDLEDRAG,
	COLOR_POWERKEYP,
	COLOR_POWERKEYS,
	COLOR_POWERKEYR,

	COLOR_TEXT_TAB_ACTIVE,

	COLOR_QUICKTAB_BORDER,
	COLOR_QUICKTAB_BG_INACTIVE,
	COLOR_QUICKTAB_BG_ACTIVE,
	COLOR_QUICKTAB_TEXT_INACTIVE,
	COLOR_QUICKTAB_TEXT_ACTIVE,
	COLOR_QUICKBAR_TEXT,
	COLOR_QUICKBAR_BG,
	COLOR_QUICKBAR_TEXT2,
	COLOR_QUICKBAR_BG2,
	COLOR_ICONS_BG_ACTIVE,
	COLOR_BORDER_PALETTE,
	COLOR_PALETTE_TEXT,
	COLOR_PALETTE_TEXT_DISABLED,
	COLOR_PALETTE_TEXT_SELECTED,
	COLOR_PALETTE_SEPARATOR,

	COLOR_BORDER_ACTIVE_1,
	COLOR_BORDER_ACTIVE_3,
	COLOR_BORDER_ACTIVE_4,
	COLOR_MENU_BG_BORDER,

	COLOR_CTIMELINE_BREAKDOWN,
	COLOR_CTIMELINE_HLECURVE,

	COLOR_BG_GROUP1,
	COLOR_BG_GROUP2,
	COLOR_POWERSOUND,
	COLOR_BG_GROUPBAR1,
	COLOR_BG_GROUPBAR2,

	COLOR_CTIMELINE_CLIPTEXT,
	COLOR_CTIMELINE_CLIP,
	COLOR_CTIMELINE_CLIPMASTER,

	COLOR_BUBBLE_BG,
	COLOR_BUBBLE_FG,
	COLOR_BUBBLE_BORDER,

	COLOR_CTIMELINE_CLIPTEXTHL,
	COLOR_TRACK_X,
	COLOR_TRACK_Y,
	COLOR_TRACK_Z,
	COLOR_TRACK_S,

	COLOR_CTIMELINE_ANIM,
	EX_COLOR_AM_ANIMDOT_CHANGED,
	EX_COLOR_AM_BPDOT,
	COLOR_PV_BUCKET,
	COLOR_PV_TEXT,
	COLOR_PV_CACHE,
	COLOR_PV_NOTALL,
	COLOR_PV_COMPARE,
	COLOR_PV_FPS,

	COLOR_PROGRESSBAR,

	COLOR_RM_QUEUE,
	COLOR_RM_ERROR,
	COLOR_RM_STOP,
	COLOR_RM_PROG,
	COLOR_RM_FINISHED,

	COLOR_PV_NAVIAREA,
	COLOR_PV_HISTO,
	COLOR_PV_HISTOFILTER,

	COLOR_PV_HDLOW,
	COLOR_PV_HDMED,
	COLOR_PV_HDHIGH,

	COLOR_PV_FULLBG,
	COLOR_PV_FULLTXT,
	COLOR_PV_FULLELE,
	COLOR_PV_FULLBOR,

	COLOR_PV_ASAFE,
	COLOR_PV_TSAFE,

	COLOR_CTIMELINE_SPLINE,

	COLOR_QUICKTAB_BG_ACTIVE_ALTERNATE1,
	EX_COLOR_AM_ANIMDOT_MUTED,

	COLOR_XPRESSO_BACKGROUND,
	COLOR_XPRESSO_GRID,
	COLOR_CTIMELINE_BGTEXTCOLOR,
	COLOR_CTIMELINE_GRIDMAIN,

	COLOR_ICONS_BG_HIGHLIGHT,
	COLOR_ICONS_BG_ACTIVE_HIGHLIGHT,
	COLOR_BG_HIGHLIGHT,
	COLOR_MENU_BG_HIGHLIGHT,
	COLOR_MENU_TEXT_HIGHLIGHT,
	COLOR_ICONS_TEXT_HIGHLIGHT,

	COLOR_DUMMY_
};

#endif
